// Copyright 2018 Sourcerer Inc. All Rights Reserved.
// Author: Alexander Surkov (alex@sourcerer.io)

package test.tests.extractors

/**
 * A list of all file names whose language recognition needs to be checked
 * or fixed.
 */
var ignoredSamplesWildcards = listOf(
    "*/1C Enterprise/*",
    "*/ABAP/*",
    "*/AppleScript/*",
    "*/Apex/*",
    "*/APL/*",
    "*/API Blueprint/*",
    "*/Alloy/*",
    "*/Apollo Guidance Computer/*",
    "*/ASN.1/*",
    "*/Awk/*",
    "*/Ant Build System/*",
    "*/Alpine Abuild/*",
    "*/AspectJ/*",
    "*/AMPL/*",
    "*/AutoHotkey/*",
    "*/AsciiDoc/*",
    "*/Agda/*",
    "*/ATS/*",
    "*/ApacheConf/*",
    "*/AGS Script/*",
    "*/Adobe Font Metrics/*",
    "*/Brightscript/*",
    "*/Bluespec/*",
    "*/Blade/*",
    "*/Brainfuck/*",
    "*/BlitzBasic/*",
    "*/BitBake/*",
    "*/Ballerina/*",
    "*/BlitzMax/*",
    "*/C/script",
    "*/C/*.cats",
    "*/C/jni_layer.h",
    "*/C++/Field.h",
    "*/C++/rpc.h",
    "*/C++/*.inc",
    "*/C++/*.re",
    "*/C++/*.ino",
    "*/C++/*.ipp",
    "*/CartoCSS/*.mss",
    "*/CLIPS/*",
    "*/CMake/*",
    "*/COBOL/*.ccp",
    "*/CSON/*",
    "*/CSV/*",
    "*/CWeb/*",
    "*/CartoCSS/*",
    "*/Ceylon/*",
    "*/Chapel/*",
    "*/Charity/*",
    "*/Cirru/*",
    "*/Clarion/*",
    "*/Clean/*",
    "*/Click/*",
    "*/Closure Templates/*",
    "*/CoNLL-U/*",
    "*/CoffeeScript/*.cake",
    "*/CoffeeScript/*.cjsx",
    "*/ColdFusion/*",
    "*/ColdFusion CFC/*",
    "*/Common Workflow Language/*",
    "*/Component Pascal/*",
    "*/Cool/*",
    "*/Coq/*",
    "*/Creole/*",
    "*/Crystal/*",
    "*/Csound/*",
    "*/Csound Document/*",
    "*/Csound Score/*",
    "*/Cycript/*",
    "*/DIGITAL Command Language/*",
    "*/DM/*",
    "*/DNS Zone/*",
    "*/DataWeave/*",
    "*/Diff/*",
    "*/Dockerfile/*",
    "*/Dogescript/*",
    "*/E/*",
    "*/EBNF/*",
    "*/ECL/*",
    "*/ECLiPSe/*",
    "*/EJS/*",
    "*/EQ/*",
    "*/Eagle/*",
    "*/Easybuild/*",
    "*/Edje Data Collection/*",
    "*/Eiffel/*",
    "*/Elixir/*",
    "*/Emacs Lisp/*",
    "*/EmberScript/*",
    "*/Erlang/*.es",
    "*/Erlang/*.src",
    "*/Erlang/*.escript",
    "*/Erlang/factorial",
    "*/Erlang/release",
    "*/Erlang/*.xrl",
    "*/Erlang/filenames/*",
    "*/Erlang/*.yrl",
    "*/FLUX/*",
    "*/Fantom/*",
    "*/Formatted/*",
    "*/FreeMarker/*",
    "*/Frege/*",
    "*/G-code/*",
    "*/GAMS/*",
    "*/GAP/*",
    "*/GCC Machine Description/*",
    "*/GDB/*",
    "*/GDScript/*",
    "*/GN/*",
    "*/Game Maker Language/*",
    "*/Genie/*",
    "*/Gerber Image/*",
    "*/Gnuplot/*",
    "*/Golo/*",
    "*/Gosu/*",
    "*/Grace/*",
    "*/Grammatical Framework/*",
    "*/Graph Modeling Language/*",
    "*/GraphQL/*",
    "*/Graphviz (DOT)/*",
    "*/Groovy/*",
    "*/Groovy Server Pages/*",
    "*/HCL/*",
    "*/HLSL/*",
    "*/HTML/*.inc",
    "*/HTML/*.hl",
    "*/HTML/*.st",
    "*/HTML/*.xht",
    "*/HTML+Django/*",
    "*/HTML+ECR/*",
    "*/HTML+EEX/*",
    "*/HTML+ERB/*",
    "*/HXML/*",
    "*/Hack/*.hh",
    "*/Haml/*",
    "*/Handlebars/*",
    "*/HyPhy/*",
    "*/IGOR Pro/*",
    "*/INI/filenames/*.spec",
    "*/INI/filenames/.editorconfig",
    "*/INI/filenames/.gitconfig",
    "*/Idris/*",
    "*/Inform 7/*",
    "*/Inno Setup/*",
    "*/Ioke/*",
    "*/Isabelle/*",
    "*/Isabelle ROOT/*",
    "*/J/hashbang",
    "*/JFlex/*",
    "*/JSON/*",
    "*/JSON5/*",
    "*/JSONLD/*",
    "*/JSONiq/*",
    "*/JSX/*",
    "*/Jasmin/*",
    "*/JavaScript/*.mjs",
    "*/JavaScript/*.xsjs",
    "*/JavaScript/*.jscad",
    "*/JavaScript/js",
    "*/JavaScript/jquery-1.4.2.min.js",
    "*/JavaScript/jquery-1.6.1.min.js",
    "*/JavaScript/*.gs",
    "*/JavaScript/*.es",
    "*/JavaScript/*.jsb",
    "*/JavaScript/*.frag",
    "*/JavaScript/*.xsjslib",
    "*/JavaScript/js2",
    "*/Jison/*",
    "*/Jison Lex/*",
    "*/Jolie/*",
    "*/Julia/julia",
    "*/Jupyter Notebook/*",
    "*/KRL/*",
    "*/KiCad Layout/*",
    "*/KiCad Legacy Layout/*",
    "*/KiCad Schematic/*",
    "*/Kit/*",
    "*/LFE/*",
    "*/LOLCODE/*",
    "*/LSL/*",
    "*/Lasso/*",
    "*/Latte/*",
    "*/Lean/*",
    "*/Less/*",
    "*/Linker Script/*",
    "*/Linux Kernel Module/*",
    "*/Liquid/*",
    "*/Literate Agda/*",
    "*/Literate CoffeeScript/*",
    "*/LiveScript/*",
    "*/Logos/*",
    "*/Logtalk/*",
    "*/LookML/*",
    "*/LoomScript/*",
    "*/M/mileage.m",
    "*/M4/*",
    "*/M4Sugar/*",
    "*/MAXScript/*",
    "*/MQL4/*",
    "*/MQL5/*",
    "*/MTML/*",
    "*/Makefile/makefile",
    "*/Makefile/filenames/*",
    "*/Markdown/*",
    "*/Marko/*",
    "*/Mask/*",
    "*/Matlab/matlab_class.m",
    "*/Matlab/Check_plot.m",
    "*/Matlab/normalize.m",
    "*/Maven POM/*",
    "*/Max/*",
    "*/MediaWiki/*",
    "*/Mercury/expr.moo",
    "*/Meson/*",
    "*/Metal/*",
    "*/Modelica/*",
    "*/Modula-2/*",
    "*/Module Management System/*",
    "*/Monkey/*",
    "*/Moocode/*",
    "*/MoonScript/*",
    "*/NCL/*",
    "*/NL/*",
    "*/NSIS/*",
    "*/Nearley/*",
    "*/Nemerle/*",
    "*/NetLinx/*",
    "*/NetLinx+ERB/*",
    "*/NetLogo/*",
    "*/Nextflow/*",
    "*/Nginx/*",
    "*/Nim/*",
    "*/Nit/*",
    "*/Nix/*",
    "*/Nu/*",
    "*/OCaml/sigset.ml",
    "*/OCaml/common.ml",
    "*/OCaml/date.ml",
    "*/Objective-C/cocoa_monitor.m",
    "*/Objective-C++/*",
    "*/Objective-J/*",
    "*/Omgrofl/*",
    "*/Opa/*",
    "*/Opal/*",
    "*/OpenCL/*",
    "*/OpenEdge ABL/*",
    "*/OpenRC runscript/*",
    "*/OpenSCAD/*",
    "*/Org/*",
    "*/Ox/*",
    "*/Oz/*",
    "*/P4/*",
    "*/PAWN/*",
    "*/PHP/*.fcgi",
    "*/PHP/php*",
    "*/PHP/filenames/.php_cs",
    "*/PHP/filenames/.php_cs.dist",
    "*/Pan/*",
    "*/Papyrus/*",
    "*/Parrot Assembly/*",
    "*/Parrot Internal Representation/*",
    "*/Pep8/*",
    "*/Perl/perl",
    "*/Perl/filenames/cpanfile",
    "*/Perl/filenames/Rexfile",
    "*/Perl/filenames/ack",
    "*/Perl/feedgnuplot",
    "*/Perl 6/man-or-boy.t",
    "*/Pic/*",
    "*/Pickle/*",
    "*/PigLatin/*",
    "*/Pike/*",
    "*/Pod/*",
    "*/PogoScript/*",
    "*/Pony/*",
    "*/PostCSS/*",
    "*/PostScript/*",
    "*/PowerBuilder/*",
    "*/Prolog/dleak-report",
    "*/Propeller Spin/*",
    "*/Protocol Buffer/*",
    "*/Public Key/*",
    "*/Pug/*",
    "*/PureBasic/*",
    "*/PureScript/*",
    "*/Python/*.pyi",
    "*/Python/python*",
    "*/Python/*.gypi",
    "*/Python/filenames/*",
    "*/Python/*.spec",
    "*/Python/*.pyde",
    "*/Python/*.cgi",
    "*/Python/*.bzl",
    "*/Python/*.pyp",
    "*/Python/*.fcgi",
    "*/QML/*",
    "*/QMake/qmake",
    "*/QMake/functions.pri",
    "*/R/filenames/expr-dist",
    "*/R/git-punchcard",
    "*/RAML/*",
    "*/RDoc/*",
    "*/REXX/*",
    "*/RMarkdown/*",
    "*/RPC/*",
    "*/RPM Spec/*",
    "*/RUNOFF/*",
    "*/Racket/*",
    "*/Ragel/*",
    "*/Rascal/*",
    "*/Reason/*",
    "*/Red/*",
    "*/Regular Expression/*",
    "*/Ring/*",
    "*/RobotFramework/*",
    "*/Ruby/*spec",
    "*/Ruby/rexpl",
    "*/Ruby/ruby*",
    "*/Ruby/*jbuilder",
    "*/Ruby/filenames/*",
    "*/Ruby/*.fcgi",
    "*/Ruby/*.rabl",
    "*/Ruby/macruby",
    "*/Ruby/*.rake",
    "*/Ruby/shoes-swt",
    "*/SCSS/*",
    "*/SMT/*",
    "*/SPARQL/*",
    "*/SQF/*",
    "*/SQL/hostcache_set_state.inc",
    "*/SQL/AvailableInSearchSel.prc",
    "*/SQLPL/check_reorg.sql",
    "*/SQLPL/runstats.sql",
    "*/SQLPL/sleep.sql",
    "*/SQLPL/create_stuff.sql",
    "*/SRecode Template/*",
    "*/STON/*",
    "*/Sage/*",
    "*/SaltStack/*",
    "*/Sass/*",
    "*/Scala/99*",
    "*/Scala/scala",
    "*/Scaml/*",
    "*/Scilab/*",
    "*/ShaderLab/*",
    "*/Shell/*.command",
    "*/Shell/*zsh",
    "*/Shell/99-bottles-of-beer",
    "*/Shell/*cgi",
    "*/Shell/plugin",
    "*/Shell/*bash",
    "*/Shell/sh",
    "*/Shell/filenames/*",
    "*/Shell/sbt",
    "*/Shell/*.tool",
    "*/Shell/string-chopping",
    "*/ShellSession/*",
    "*/Shen/*",
    "*/Slash/*",
    "*/Slim/*",
    "*/Smali/*",
    "*/SourcePawn/*",
    "*/Squirrel/*",
    "*/Stan/*",
    "*/Standard ML/*",
    "*/Stata/*",
    "*/Stylus/*",
    "*/SubRip Text/*",
    "*/Sublime Text Config/*",
    "*/SugarSS/*",
    "*/SystemVerilog/*",
    "*/TI Program/*",
    "*/TLA/*",
    "*/TOML/*",
    "*/TXL/*",
    "*/Tcl/filenames/starfield",
    "*/Tcl/filenames/owh",
    "*/Tcl/*.tm",
    "*/Tea/*",
    "*/Terra/*",
    "*/Text/*",
    "*/Thrift/*",
    "*/Turing/*",
    "*/Turtle/*",
    "*/Type Language/*",
    "*/Unity3D Asset/*",
    "*/Unix Assembly/*",
    "*/Uno/*",
    "*/UnrealScript/*",
    "*/UrWeb/*",
    "*/VCL/*",
    "*/VHDL/*",
    "*/Vim script/*",
    "*/Volt/*",
    "*/Wavefront Material/*",
    "*/Wavefront Object/*",
    "*/Web Ontology Language/*",
    "*/WebAssembly/*",
    "*/WebIDL/*",
    "*/World of Warcraft Addon Data/*",
    "*/X10/*",
    "*/XC/*",
    "*/XCompose/*",
    "*/XML/XmlIO.pluginspec",
    "*/XML/*.wixproj",
    "*/XML/*.proj",
    "*/XML/*.sch",
    "*/XML/*.mm",
    "*/XML/*.config",
    "*/XML/*.targets",
    "*/XML/*.mod",
    "*/XPages/*",
    "*/XProc/*",
    "*/XQuery/*",
    "*/XS/*",
    "*/XSLT/*",
    "*/Xojo/*",
    "*/YAML/*",
    "*/YANG/*",
    "*/YARA/*",
    "*/Zephir/*",
    "*/Zimpl/*",
    "*/desktop/*",
    "*/eC/*",
    "*/edn/*",
    "*/fish/*",
    "*/reStructuredText/*",
    "*/sed/*",
    "*/wdl/*",
    "*/wisp/*",
    "*/xBase/*"
)
